# valarray_meta.h File Reference

This graph shows which files directly or indirectly include this file:

Go to the source code of this file.

## Namespaces

namespace | std

## Detailed Description

This is an internal header file, included by other library headers. You should not attempt to use it directly.

Definition in file valarray_meta.h.

## Define Documentation

#define _DEFINE_EXPR_UNARY_FUNCTION | ( | _Name |  | ) |

Value:

    template<class _Dom>                                                    \
    inline _Expr<_UnFunClos<_Expr,_Dom>,typename _Dom::value_type>          \
    _Name(const _Expr<_Dom,typename _Dom::value_type>& __e)                 \
    {                                                                       \
        typedef typename _Dom::value_type _Tp;                              \
        typedef _UnFunClos<_Expr,_Dom> _Closure;                            \
        return _Expr<_Closure,_Tp>(_Closure(__e(), (_Tp(*)(_Tp))(&_Name))); \
    }                                                                       \
                                                                            \
    template<typename _Tp>                                                  \
    inline _Expr<_UnFunClos<_ValArray,_Tp>,_Tp>                             \
    _Name(const valarray<_Tp>& __v)                                         \
    {                                                                       \
        typedef _UnFunClos<_ValArray,_Tp> _Closure;                         \
        return _Expr<_Closure,_Tp> (_Closure (__v, (_Tp(*)(_Tp))(&_Name))); \
    }

Definition at line 939 of file valarray_meta.h.

#define _DEFINE_EXPR_UNARY_OPERATOR | ( | _Op,
|  | _Name |  | ) |

Value:

    template<class _Dom, typename _Tp>                                      \
    inline _Expr<_UnClos<_Name,std::_Expr,_Dom>,_Tp>                        \
    _Expr<_Dom,_Tp>::operator _Op () const                                 \
    {                                                                       \
        typedef _UnClos<_Name,std::_Expr,_Dom> _Closure;                    \
        return _Expr<_Closure,_Tp> (_Closure (this->_M_closure));           \
    }

Definition at line 781 of file valarray_meta.h.